/* Copyright (c) 1997-2010
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: Matrix_3.cc 9552 2010-03-09 14:58:12Z paffenho $
*/

#define DIMENSION_CHECKS 1
#define INDEX_CHECKS 1

#include <polymake.h>
#include <Matrix.h>
#include <Rational.h>
#include <Integer.h>
#include <Vector.h>
#include <SparseMatrix.h>
#include <linalg.h>
#include <Set.h>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   template <typename T0, typename T1>
   FunctionInterface4perl( new_X, T0,T1 ) {
      perl::Value arg0(stack[1]);
      WrapperReturnNew(T0, (arg0.get<T1>()) );
   };

   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Integer > >, perl::Canned< const SparseMatrix< Integer, NonSymmetric > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< Integer > >, perl::Canned< const pm::Transposed<pm::Matrix<pm::Integer> > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Matrix< double > >, perl::Canned< const pm::Transposed<pm::Matrix<double> > >);
   OperatorInstance4perl(Unary_not, perl::Canned< const Matrix< double > >);
   OperatorInstance4perl(convert, Matrix< Integer >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(convert, Matrix< Rational >, perl::Canned< const Matrix< int > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::Matrix<pm::Rational> const&, pm::SingleRow<pm::Vector<pm::Rational> const&> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::IndexedSlice<pm::masquerade<pm::ConcatRows, pm::Matrix<pm::Rational>&>, pm::Series<int, true>, void> >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::Matrix<pm::Rational> const&, pm::Matrix<pm::Rational> const&> >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::RowChain<pm::RowChain<pm::Matrix<pm::Rational> const&, pm::Matrix<pm::Rational> const&> const&, pm::Matrix<pm::Rational> const&> >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Matrix< Rational > >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const SparseMatrix< Rational, Symmetric > >);
   OperatorInstance4perl(convert, Matrix< Rational >, perl::Canned< const SparseMatrix< Rational, Symmetric > >);
   OperatorInstance4perl(assign, Matrix< Rational >, perl::Canned< const SparseMatrix< Rational, Symmetric > >);
   OperatorInstance4perl(Binary__or, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::SameElementVector<pm::Rational> >);
   OperatorInstance4perl(convert, Matrix< int >, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(convert, Matrix< Rational >, perl::Canned< const Matrix< Integer > >);
   OperatorInstance4perl(Binary_div, perl::Canned< const Matrix< double > >, perl::Canned< const Vector< double > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Matrix< Rational > >, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&> >);
   OperatorInstance4perl(convert, Matrix< Rational >, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&> >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::all_selector const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&> >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary__or, perl::Canned< const pm::Transposed<pm::Matrix<int> > >, perl::Canned< const Matrix< int > >);
   OperatorInstance4perl(assign, pm::MatrixMinor<pm::Matrix<int>&, pm::Series<int, true> const&, pm::Series<int, true> const&>, perl::Canned< const pm::Transposed<pm::Matrix<int> > >);
   FunctionInstance4perl(new_X, Matrix< int >, perl::Canned< const SparseMatrix< int, NonSymmetric > >);
   FunctionInstance4perl(new_X, Matrix< int >, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::all_selector const&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&> >);
   FunctionInstance4perl(new_X, Matrix< int >, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >);
   FunctionInstance4perl(new_X, Matrix< int >, perl::Canned< const pm::MatrixMinor<pm::Transposed<pm::Matrix<pm::Rational> >&, pm::Complement<pm::SingleElementSet<int const&>, int, pm::operations::cmp> const&, pm::all_selector const&> >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
