/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: Set.cc 9581 2010-03-16 19:33:46Z herr $
*/

#include <polymake.h>
#include <Set.h>
#include <IncidenceMatrix.h>
#include <Array.h>
#include <Graph.h>
#include <Matrix.h>
#include <Rational.h>
#include <Vector.h>
#include <FacetList.h>
#include <list>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   template <typename T0, typename T1>
   FunctionInterface4perl( new_X, T0,T1 ) {
      perl::Value arg0(stack[1]);
      WrapperReturnNew(T0, (arg0.get<T1>()) );
   };

   template <typename T0>
   FunctionInterface4perl( new, T0 ) {
      WrapperReturnNew(T0, () );
   };

   ClassTemplate4perl("Polymake::common::Set");
   Class4perl("Polymake::common::Set__Int", Set< int >);
   FunctionInstance4perl(new, Set< int >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Binary_mul, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Unary_com, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const pm::Series<int, true> >, perl::Canned< const Set< int > >);
   Class4perl("Polymake::common::Set__Set__Int", Set< Set< int > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Set< int > >, int);
   FunctionInstance4perl(new, Set< Set< int > >);
   OperatorInstance4perl(Binary_add, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   Class4perl("Polymake::common::Set__Vector__Rational", Set< Vector< Rational > >);
   FunctionInstance4perl(new, Set< Vector< Rational > >);
   OperatorInstance4perl(BinaryAssign_add, perl::Canned< Set< Vector< Rational > > >, perl::Canned< const Vector< Rational > >);
   OperatorInstance4perl(Binary__eq, perl::Canned< const Set< int > >, perl::Canned< const pm::facet_list::Facet >);
   OperatorInstance4perl(Binary__lt, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Binary__gt, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Binary_add, perl::Canned< const pm::Series<int, true> >, perl::Canned< const pm::Series<int, true> >);
   OperatorInstance4perl(BinaryAssign_add, perl::Canned< pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::graph::traits_base<pm::graph::Undirected, false, (pm::sparse2d::restriction_kind)0>, true, (pm::sparse2d::restriction_kind)0> > > >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Binary_sub, perl::Canned< const pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::graph::traits_base<pm::graph::Undirected, false, (pm::sparse2d::restriction_kind)0>, true, (pm::sparse2d::restriction_kind)0> > > >, perl::Canned< const Set< int > >);
   FunctionInstance4perl(new_X, Set< int >, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(new_X, Set< int >, perl::Canned< const Set< int > >);
   OperatorInstance4perl(Unary_com, perl::Canned< const pm::SingleElementSet<int const&> >);
   OperatorInstance4perl(assign, Set< int >, perl::Canned< const pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::sparse2d::traits_base<pm::nothing, true, false, (pm::sparse2d::restriction_kind)0>, false, (pm::sparse2d::restriction_kind)0> > const&> >);
   OperatorInstance4perl(assign, Set< int >, perl::Canned< const pm::SingleElementSet<int const&> >);
   OperatorInstance4perl(assign, Set< int >, perl::Canned< const std::pair< Array< Set< int > >, Array< Set< int > > > >);
   OperatorInstance4perl(assign, Set< int >, perl::Canned< const pm::Series<int, true> >);
   FunctionInstance4perl(new_X, Set< int >, perl::Canned< const pm::incidence_line<pm::AVL::tree<pm::sparse2d::traits<pm::sparse2d::traits_base<pm::nothing, true, false, (pm::sparse2d::restriction_kind)0>, false, (pm::sparse2d::restriction_kind)0> > const&> >);
   OperatorInstance4perl(BinaryAssign_add, perl::Canned< Set< int > >, perl::Canned< const Set< int > >);
   Class4perl("Polymake::common::Set__Array__Int", Set< Array< int > >);
   OperatorInstance4perl(Binary__ne, perl::Canned< const Set< int > >, perl::Canned< const Set< int > >);
   FunctionInstance4perl(new, Set< Array< int > >);
   OperatorInstance4perl(assign, Set< int >, perl::Canned< const pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> >);
   OperatorInstance4perl(assign, Set< int >, perl::Canned< const IncidenceMatrix< NonSymmetric > >);
   Class4perl("Polymake::common::Set__Array__Set__Int", Set< Array< Set< int > > >);
   Class4perl("Polymake::common::Set__List__Int", Set< std::list< int > >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
