/* Copyright (c) 1997-2009
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: SparseMatrix.cc 9558 2010-03-10 14:47:10Z sherrmann $
*/

#define DIMENSION_CHECKS 1

#include <polymake.h>
#include <SparseMatrix.h>
#include <Rational.h>
#include <Matrix.h>
#include <IncidenceMatrix.h>
#include <Integer.h>
#include <linalg.h>
#include <Array.h>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   template <typename T0>
   FunctionInterface4perl( new_int_int, T0 ) {
      perl::Value arg0(stack[1]), arg1(stack[2]);
      WrapperReturnNew(T0, (arg0.get<int>(), arg1.get<int>()) );
   };

   template <typename T0, typename T1>
   FunctionInterface4perl( new_X, T0,T1 ) {
      perl::Value arg0(stack[1]);
      WrapperReturnNew(T0, (arg0.get<T1>()) );
   };

   template <typename T0>
   FunctionInterface4perl( new, T0 ) {
      WrapperReturnNew(T0, () );
   };

   Class4perl("Polymake::common::SparseMatrix_A_Rational_I_NonSymmetric_Z", SparseMatrix< Rational, NonSymmetric >);
   ClassTemplate4perl("Polymake::common::SparseMatrix");
   FunctionInstance4perl(new, SparseMatrix< double, NonSymmetric >);
   FunctionInstance4perl(new, SparseMatrix< Rational, NonSymmetric >);
   Class4perl("Polymake::common::SparseMatrix_A_Rational_I_Symmetric_Z", SparseMatrix< Rational, Symmetric >);
   Class4perl("Polymake::common::SparseMatrix_A_Float_I_NonSymmetric_Z", SparseMatrix< double, NonSymmetric >);
   Class4perl("Polymake::common::SparseMatrix_A_Int_I_NonSymmetric_Z", SparseMatrix< int, NonSymmetric >);
   Class4perl("Polymake::common::SparseMatrix_A_Integer_I_Symmetric_Z", SparseMatrix< Integer, Symmetric >);
   FunctionInstance4perl(new, SparseMatrix< Rational, Symmetric >);
   Class4perl("Polymake::common::SparseMatrix_A_Integer_I_NonSymmetric_Z", SparseMatrix< Integer, NonSymmetric >);
   FunctionInstance4perl(new, SparseMatrix< Integer, NonSymmetric >);
   Class4perl("Polymake::common::SparseMatrix_A_Int_I_Symmetric_Z", SparseMatrix< int, Symmetric >);
   FunctionInstance4perl(new_X, SparseMatrix< double, NonSymmetric >, perl::Canned< const Matrix< double > >);
   FunctionInstance4perl(new_int_int, SparseMatrix< Rational, NonSymmetric >);
   FunctionInstance4perl(new_int_int, SparseMatrix< Integer, NonSymmetric >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const SparseMatrix< Integer, NonSymmetric > >);
   FunctionInstance4perl(new_X, SparseMatrix< double, NonSymmetric >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const Matrix< Rational > >);
   FunctionInstance4perl(new_int_int, SparseMatrix< double, NonSymmetric >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, Symmetric >, perl::Canned< const pm::DiagMatrix<pm::SameElementVector<pm::Rational> > >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const pm::BlockDiagMatrix<pm::DiagMatrix<pm::SingleElementVector<pm::Rational>, false>, pm::Matrix<pm::Rational> const&, false> >);
   FunctionInstance4perl(new_int_int, SparseMatrix< int, NonSymmetric >);
   FunctionInstance4perl(new, SparseMatrix< int, NonSymmetric >);
   FunctionInstance4perl(new_X, SparseMatrix< int, NonSymmetric >, perl::Canned< const Matrix< int > >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const pm::BlockDiagMatrix<pm::DiagMatrix<pm::SingleElementVector<pm::Rational>, false>, pm::DiagMatrix<pm::SameElementVector<pm::Rational>, true> const&, false> >);
   OperatorInstance4perl(Binary_div, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >, perl::Canned< const SparseMatrix< Rational, NonSymmetric > >);
   DisabledFunction4perl(:_or, int, perl::Canned< const pm::DiagMatrix<pm::SameElementVector<pm::Rational>, true> >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const pm::ColChain<pm::SingleCol<pm::SameElementVector<pm::Rational> const&>, pm::DiagMatrix<pm::SameElementVector<pm::Rational>, true> const&> >);
   OperatorInstance4perl(convert, SparseMatrix< int, NonSymmetric >, perl::Canned< const Matrix< Integer > >);
   FunctionInstance4perl(new_X, SparseMatrix< Rational, NonSymmetric >, perl::Canned< const SparseMatrix< int, NonSymmetric > >);
   FunctionInstance4perl(new_X, SparseMatrix< int, NonSymmetric >, perl::Canned< const Matrix< Rational > >);
   OperatorInstance4perl(convert, SparseMatrix< int, NonSymmetric >, perl::Canned< const Matrix< Rational > >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
