/* Copyright (c) 1997-2010
   Ewgenij Gawrilow, Michael Joswig (Technische Universitaet Darmstadt, Germany)
   http://www.polymake.de

   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 2, or (at your option) any
   later version: http://www.gnu.org/licenses/gpl.txt.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
--------------------------------------------------------------------------------
   $Project: polymake $$Id: auto-cols.cc 9558 2010-03-10 14:47:10Z sherrmann $
*/

#include <polymake.h>
#include <Matrix.h>
#include <Rational.h>
#include <IncidenceMatrix.h>
#include <SparseMatrix.h>
#include <Set.h>
#include <Vector.h>
#include <Integer.h>
#include <linalg.h>
#include <Array.h>

namespace polymake { namespace common {
///==== Automatically generated contents follow.    Please do not delete this line. ====
   template <typename T0>
   FunctionInterface4perl( cols_f1, T0 ) {
      perl::Value arg0(stack[0]);
      WrapperReturn( arg0.get<T0>().cols() );
   };

   FunctionInstance4perl(cols_f1, perl::Canned< const Matrix< Rational > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const IncidenceMatrix< NonSymmetric > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const Matrix< double > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::RowChain<pm::Matrix<Rational> const&, pm::Matrix<Rational> const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::RowChain<pm::Matrix<double> const&, pm::Matrix<double> const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const SparseMatrix< Rational > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::Matrix<double>&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::Matrix<Rational> const&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const SparseMatrix< double > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::Matrix<Rational> const&, pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::all_selector const&, pm::Series<int, true> const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::RowChain<pm::Matrix<pm::Rational> const&, pm::MatrixMinor<pm::Matrix<pm::Rational> const&, pm::Complement<pm::Set<int, pm::operations::cmp>, int, pm::operations::cmp> const&, pm::all_selector const&> const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::RowChain<pm::SparseMatrix<pm::Rational, pm::NonSymmetric> const&, pm::Matrix<pm::Rational> const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const Matrix< Integer > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::DiagMatrix<pm::SameElementVector<pm::Rational> > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::RowChain<pm::SingleRow<pm::Vector<double> const&>, pm::Matrix<double> const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const SparseMatrix< Integer, NonSymmetric > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::Transposed<pm::Matrix<int> > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const Matrix< int > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::DiagMatrix<pm::SameElementVector<int> > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::Transposed<pm::Matrix<pm::Rational> > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::MatrixMinor<pm::Matrix<double>&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&>&, pm::Array<int, void> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::Matrix<double>&, pm::Series<int, true> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::MatrixMinor<pm::Matrix<double>&, pm::Series<int, true> const&, pm::all_selector const&>&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::MatrixMinor<pm::MatrixMinor<pm::MatrixMinor<pm::Matrix<double>&, pm::Series<int, true> const&, pm::all_selector const&>&, pm::Set<int, pm::operations::cmp> const&, pm::all_selector const&>&, pm::Array<int, void> const&, pm::all_selector const&> >);
   FunctionInstance4perl(cols_f1, perl::Canned< const SparseMatrix< Rational, Symmetric > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const pm::Transposed<pm::Matrix<pm::Integer> > >);
   FunctionInstance4perl(cols_f1, perl::Canned< const SparseMatrix< int, NonSymmetric > >);
///==== Automatically generated contents end here.  Please do not delete this line. ====
} }
